// Code generated by mockery v2.12.1. DO NOT EDIT.

package mocks

import (
	dao "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dao"
	dto "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dto"

	mock "github.com/stretchr/testify/mock"

	testing "testing"
)

// BookService is an autogenerated mock type for the BookService type
type BookService struct {
	mock.Mock
}

// CreateBook provides a mock function with given fields: book
func (_m *BookService) CreateBook(book dto.CreateBookRequestDTO) (dao.Book, error) {
	ret := _m.Called(book)

	var r0 dao.Book
	if rf, ok := ret.Get(0).(func(dto.CreateBookRequestDTO) dao.Book); ok {
		r0 = rf(book)
	} else {
		r0 = ret.Get(0).(dao.Book)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dto.CreateBookRequestDTO) error); ok {
		r1 = rf(book)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteBook provides a mock function with given fields: id
func (_m *BookService) DeleteBook(id uint64) error {
	ret := _m.Called(id)

	var r0 error
	if rf, ok := ret.Get(0).(func(uint64) error); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// FilterBook provides a mock function with given fields: keys
func (_m *BookService) FilterBook(keys []string) ([]dto.SearchFilterBookDTO, error) {
	ret := _m.Called(keys)

	var r0 []dto.SearchFilterBookDTO
	if rf, ok := ret.Get(0).(func([]string) []dto.SearchFilterBookDTO); ok {
		r0 = rf(keys)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dto.SearchFilterBookDTO)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func([]string) error); ok {
		r1 = rf(keys)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetAllBook provides a mock function with given fields:
func (_m *BookService) GetAllBook() ([]dto.BookDTO, error) {
	ret := _m.Called()

	var r0 []dto.BookDTO
	if rf, ok := ret.Get(0).(func() []dto.BookDTO); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dto.BookDTO)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetBook provides a mock function with given fields: id_user, id_book
func (_m *BookService) GetBook(id_user uint64, id_book uint64) (dto.BookDTO, error) {
	ret := _m.Called(id_user, id_book)

	var r0 dto.BookDTO
	if rf, ok := ret.Get(0).(func(uint64, uint64) dto.BookDTO); ok {
		r0 = rf(id_user, id_book)
	} else {
		r0 = ret.Get(0).(dto.BookDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64, uint64) error); ok {
		r1 = rf(id_user, id_book)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetBooksByCategoryId provides a mock function with given fields: id
func (_m *BookService) GetBooksByCategoryId(id uint64) ([]dao.Book, error) {
	ret := _m.Called(id)

	var r0 []dao.Book
	if rf, ok := ret.Get(0).(func(uint64) []dao.Book); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Book)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCategoryByBookId provides a mock function with given fields: id
func (_m *BookService) GetCategoryByBookId(id uint64) ([]dao.Category, error) {
	ret := _m.Called(id)

	var r0 []dao.Category
	if rf, ok := ret.Get(0).(func(uint64) []dao.Category); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Category)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetHomeData provides a mock function with given fields: id
func (_m *BookService) GetHomeData(id uint) (dto.HomeDTO, error) {
	ret := _m.Called(id)

	var r0 dto.HomeDTO
	if rf, ok := ret.Get(0).(func(uint) dto.HomeDTO); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(dto.HomeDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SearchBook provides a mock function with given fields: keys
func (_m *BookService) SearchBook(keys [2]string) ([]dto.SearchFilterBookDTO, error) {
	ret := _m.Called(keys)

	var r0 []dto.SearchFilterBookDTO
	if rf, ok := ret.Get(0).(func([2]string) []dto.SearchFilterBookDTO); ok {
		r0 = rf(keys)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dto.SearchFilterBookDTO)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func([2]string) error); ok {
		r1 = rf(keys)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateBook provides a mock function with given fields: id, book
func (_m *BookService) UpdateBook(id uint, book dto.UpdateBookRequestDTO) (dao.Book, error) {
	ret := _m.Called(id, book)

	var r0 dao.Book
	if rf, ok := ret.Get(0).(func(uint, dto.UpdateBookRequestDTO) dao.Book); ok {
		r0 = rf(id, book)
	} else {
		r0 = ret.Get(0).(dao.Book)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint, dto.UpdateBookRequestDTO) error); ok {
		r1 = rf(id, book)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewBookService creates a new instance of BookService. It also registers the testing.TB interface on the mock and a cleanup function to assert the mocks expectations.
func NewBookService(t testing.TB) *BookService {
	mock := &BookService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
